module ser2par(SCLK, SD, PBVAL, TS_DATA, RD, INTR, TP);
	input SCLK;
	input SD;
	input PBVAL;
	
	output [7:0] TS_DATA;
	input  RD;
	output INTR;

	output [11:0] TP;
	assign TP[0] = intr;
	assign TP[1] = rd_idx_clr;
	assign TP[2] = RD;
	assign TP[6:3] = wr_idx;
	assign TP[10:7] = rd_idx;
	assign TP[11] = TS_DATA[0];
	
	reg [7:0] pbval;
	reg [2:0] bits;
	reg [7:0] sreg;
	reg [7:0] dout0;
	reg [7:0] dout1;
	reg [7:0] dout2;
	reg [7:0] dout3;
	reg [7:0] dout4;
	reg [7:0] dout5;
	reg [7:0] dout6;
	reg [7:0] dout7;
	reg [7:0] dout8;
	reg [7:0] dout9;
	reg [7:0] dout10;
	reg [7:0] dout11;
	reg [7:0] dout12;
	reg [7:0] dout13;
	reg [7:0] dout14;
	reg [7:0] dout15;

	reg [3:0] wr_idx = 0;
	reg [3:0] rd_idx = 0;
	reg intr = 1;
	
	wire rd_idx_clr = ((wr_idx == 8) && (bits == 0)) ? 1 : 0;

	always@(posedge RD or posedge rd_idx_clr)
	begin
		if(rd_idx_clr) begin
			rd_idx <= 0;
		end else begin
			rd_idx <= rd_idx + 1;
		end
	end
	
	always@(negedge SCLK)
	begin
		pbval[0] <= PBVAL;
		pbval[7:1] <= pbval[6:0];

		if((pbval[7] == 0) && (PBVAL == 0))
			bits <= 0;
	
		else begin
			sreg[0] <= SD;
			sreg[7:1] <= sreg[6:0];
			bits <= bits + 1;
		end
			
		if((bits == 0)&&(pbval[7] == 1))
		begin
			if(wr_idx == 0)
				dout0[7:0] <= sreg[7:0];
			else if(wr_idx == 1)
				dout1[7:0] <= sreg[7:0];
			else if(wr_idx == 2)
				dout2[7:0] <= sreg[7:0];
			else if(wr_idx == 3)
				dout3[7:0] <= sreg[7:0];
			else if(wr_idx == 4)
				dout4[7:0] <= sreg[7:0];
			else if(wr_idx == 5)
				dout5[7:0] <= sreg[7:0];
			else if(wr_idx == 6)
				dout6[7:0] <= sreg[7:0];
			else if(wr_idx == 7)
				dout7[7:0] <= sreg[7:0];
			else if(wr_idx == 8)
				dout8[7:0] <= sreg[7:0];
			else if(wr_idx == 9)
				dout9[7:0] <= sreg[7:0];
			else if(wr_idx == 10)
				dout10[7:0] <= sreg[7:0];
			else if(wr_idx == 11)
				dout11[7:0] <= sreg[7:0];
			else if(wr_idx == 12)
				dout12[7:0] <= sreg[7:0];
			else if(wr_idx == 13)
				dout13[7:0] <= sreg[7:0];
			else if(wr_idx == 14)
				dout14[7:0] <= sreg[7:0];
			else if(wr_idx == 15)
				dout15[7:0] <= sreg[7:0];
			
			if((wr_idx == 0) || (wr_idx == 8))
				intr <= 0;
			else
				intr <= 1;
				
			wr_idx <= wr_idx + 1;
		end
	end
	
	assign TS_DATA = (rd_idx ==  0) ? dout0 :
	                 (rd_idx ==  1) ? dout1 :
	                 (rd_idx ==  2) ? dout2 :
	                 (rd_idx ==  3) ? dout3 :
	                 (rd_idx ==  4) ? dout4 :
	                 (rd_idx ==  5) ? dout5 :
	                 (rd_idx ==  6) ? dout6 :
	                 (rd_idx ==  7) ? dout7 :
	                 (rd_idx ==  8) ? dout8 :
	                 (rd_idx ==  9) ? dout9 :
	                 (rd_idx == 10) ? dout10 :
	                 (rd_idx == 11) ? dout11 :
	                 (rd_idx == 12) ? dout12 :
	                 (rd_idx == 13) ? dout13 :
	                 (rd_idx == 14) ? dout14 : dout15;
	
	assign INTR = intr;
endmodule
