#include <p32xxxx.h>

	.extern cbc_init

	.text
	.globl	decrypt_multi2_64
	.ent	decrypt_multi2_64
	.set	noreorder
/*
 * a0: u32 *buf
 * a1: u32 *wky
 *
 * t0: tmp
 * t1: tmp
 * t2: round
 * t3: l
 * t4: r
 * t5: cbc_l
 * t6: cbc_r
 * t7: wk0
 * t8: wk1
 * t9: wk2
 * s1: wk3
 * a3: wk4
 * v0: wk5
 * v1: wk6
 * s0: wk7
 * s2: v00ff00ff
 * s3: src_l
 * s4: src_r
 */
 	#define	buf			$a0
 	#define	wky			$a1
 	#define	len			$a2
 	
 	#define	round		$t2
 	#define	l			$t3
 	#define	r			$t4
 	#define	cbc_l		$t5
 	#define cbc_r		$t6
 	#define wk0			$t7
 	#define wk1			$t8
 	#define wk2			$t9
 	#define wk3			$s1
 	#define wk4			$a3
 	#define wk5			$v0
 	#define wk6			$v1
 	#define	wk7			$s0
 	#define v00ff00ff	$s2
 	
 	#define	src_l		$s3
 	#define	src_r		$s4
 	
decrypt_multi2_64:
	addiu	$sp, $sp,-20
	sw		$s0, 0($sp)
	sw		$s1, 4($sp)
	sw		$s2, 8($sp)
	sw		$s3, 12($sp)
	sw		$s4, 16($sp)
	
	li		v00ff00ff, 0x00ff00ff
	lw		wk0, 0(wky)
	lw		wk1, 4(wky)
	lw		wk2, 8(wky)
	lw		wk3, 12(wky)
	lw		wk4, 16(wky)
	lw		wk5, 20(wky)
	lw		wk6, 24(wky)
	lw		wk7, 28(wky)
	
	la		$t0, cbc_init
	lw		cbc_l, 0($t0)
	lw		cbc_r, 4($t0)
	
buf_loop:
	li		round, 4

	lw		$t0, 0(buf)
	rotr	$t1, $t0, 24
	and		$t1, v00ff00ff, $t1
	and		$t0, v00ff00ff, $t0
	rotr	$t0, $t0, 8
	or		l, $t0, $t1
	move	src_l, l
	lw		$t0, 4(buf)
	rotr	$t1, $t0, 24
	and		$t1, v00ff00ff, $t1
	and		$t0, v00ff00ff, $t0
	rotr	$t0, $t0, 8
	or		r, $t0, $t1
	move	src_r, r
	
round_loop:
	/*PI4(wk7)*/
	addu	$t0, r, wk7
	
	rotr	$t1, $t0, 30
	addu	$t0, $t0, $t1
	addu	$t0, $t0, 1
	
	xor		l, l, $t0
	
	/*PI3(wk5,wk6)*/
	addu	$t0, l, wk5
	
	rotr    $t1, $t0, 30
	addu	$t0, $t0, $t1
	addu	$t0, $t0, 1
	
	rotr	$t1, $t0, 24
	xor		$t0, $t1, $t0
	
	addu	$t0, $t0, wk6
	
	rotr	$t1, $t0, 31
	subu	$t0, $t1, $t0
	
	rotr	$t1, $t0, 16
	or		$t0, $t0, l
	xor		$t0, $t0, $t1
	
	xor		r, r, $t0
	
	/*PI2(wk4)*/
	addu	$t0, r, wk4
	
	rotr	$t1, $t0, 31
	addu	$t0, $t0, $t1
	subu	$t0, $t0, 1
	
	rotr	$t1, $t0, 28
	xor		$t0, $t1, $t0
	
	xor		l, l, $t0
	
	/*PI1()*/
	xor		r, r, l
	
	/*PI4(wk3)*/
	addu	$t0, r, wk3
	
	rotr	$t1, $t0, 30
	addu	$t0, $t0, $t1
	addu	$t0, $t0, 1
	
	xor		l, l, $t0
	
	/*PI3(wk1,wk2)*/
	addu	$t0, l, wk1
	
	rotr    $t1, $t0, 30
	addu	$t0, $t0, $t1
	addu	$t0, $t0, 1
	
	rotr	$t1, $t0, 24
	xor		$t0, $t1, $t0
	
	addu	$t0, $t0, wk2
	
	rotr	$t1, $t0, 31
	subu	$t0, $t1, $t0
	
	rotr	$t1, $t0, 16
	or		$t0, $t0, l
	xor		$t0, $t0, $t1
	
	xor		r, r, $t0
	
	/*PI2(wk0)*/
	addu	$t0, r, wk0
	
	rotr	$t1, $t0, 31
	addu	$t0, $t0, $t1
	subu	$t0, $t0, 1
	
	rotr	$t1, $t0, 28
	xor		$t0, $t1, $t0
	
	xor		l, l, $t0
	
	addu	round, round, -1
	bne		round, 0, round_loop
	/*PI1()*/
	xor		r, r, l
	
	xor		l, l, cbc_l
	xor		r, r, cbc_r
	move	cbc_l, src_l
	move	cbc_r, src_r

	rotr	$t0, l, 24
	and		$t0, v00ff00ff, $t0
	and		l, v00ff00ff, l
	rotr	l, l, 8
	or		l, l, $t0

	sw		l, 0(buf)

	rotr	$t0, r, 24
	and		$t0, v00ff00ff, $t0
	and		r, v00ff00ff, r
	rotr	r, r, 8
	or		r, r, $t0

	sw		r, 4(buf)
	
	addu	len, len, -8
	bne		len, 0, buf_loop
	addu	buf, buf, 8
	
	lw		$s0, 0($sp)
	lw		$s1, 4($sp)
	lw		$s2, 8($sp)
	lw		$s3, 12($sp)
	lw		$s4, 16($sp)
	addiu	$sp,$sp,20
	j		$ra
	nop

.end	decrypt_multi2_64
