#include <plib.h>
#include <stdio.h>
#include <peripheral/eth.h>
#include <assert.h>
#include "eth_phy.h"

typedef unsigned char u8;
typedef signed char s8;
typedef unsigned short int u16;
typedef signed short int s16;
typedef unsigned int u32;
typedef signed int s32;
typedef unsigned long u64;
typedef signed long s64;

/*************************
     MAC addresses
 ************************/

typedef struct _MAC_ADDR
{
    BYTE v[6];
}MAC_ADDR;      // MAC address

/*************************
    IP addresses
 ************************/

typedef union _IP_ADDR
{
    BYTE        v[4];
    WORD        w[2];
    DWORD       Val;
}IP_ADDR;           // IP address

struct ETH{
	u8	t_hwaddr[6];
	u8	s_hwaddr[6];
	u16	type;
};

struct IPH{
	u8	version;
	u8	service;
	u16	len;			//
	u16	ident;			//
	u16	frags;			//
	u8	ttl;
	u8	protocol;
	u16	chksum;			//
	u16	src_addr[2];
	u16	dest_addr[2];
};

struct UDP{
	u16	src_port;
	u16	dest_port;
	u16	len;
	u16	chksum;
};

typedef		enum{TX_DONE, TX_STORED, TX_SENDING} _tx_stat;

u32 wkey[2][8];

u32 sys_freq;

#define CTIMER_MS		(sys_freq/(2*1000))	//1msԂCoreTimerJEg鐔

#define	GetSystemClock() 		sys_freq
#define	GetPeripheralClock()	(GetSystemClock()/(1 << OSCCONbits.PBDIV))
#define	GetInstructionClock()	(GetSystemClock())

#define DEFAULT_IP_ADDR		"192.168.1.12   "
#define DEFAULT_IP_GATEWAY	"192.168.1.1    "
#define DEFAULT_IP_MASK		"255.255.255.0  "

//#define TARGET_IP			"192.168.1.20   "
#define TARGET_IP			"192.168.1.34   "
//#define TARGET_IP			"192.168.1.27   "
