/*
	PIC32 USART FUNCTION
*/
#include <plib.h>

/* override stdout */
void _mon_putc(char c)
{
	if(c==0x0a)
	{
		while(BusyUART1());
		putcUART1(0x0d);
	}
	while(BusyUART1()); /* Wait till the UART transmitter is free. */
	putcUART1(c); /* Write data into Tx. */
}

/* override stdout */
void _mon_puts(const char *s)
{
	while(*s)
		_mon_putc(*s++);
}

/* override stdin */
int _mon_getc(int canblock)
{
    while(!UARTReceivedDataIsAvailable(UART1))
        ;

    return(UARTGetDataByte(UART1));
}
